<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: plugins/d-pro/d-pro.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: plugins/d-pro/d-pro.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
*
*
* @requires device
*
* @module d-pro
*/

const device = require("../devices/device.js")
const plugin = require("../plugin.js")

var schema = {
  "cue": {
  },
  "collections": {
    "shows": {
      "type": "object",
      "title": "D-Pro Show",
      "properties": {
        "settings": {
          "type": "object",
          "description": "set the connection properties for this device",
          "required": true,
          "properties": {
            "port": {
              "type": "number",
              "default": 0,
              "required": true,
              "description": "port the device communicates with the plai framework on. 0 to set random port"
            },
            "ip": {
              "type": "string",
              "description": "the ip address of your device so the framework can send messages to it.",
              "default": "0.0.0.0"
            },
            "framework_port": {
              "type": "number",
              "description": "define a different port the device sends data to the framework on if needed."
            },
            "path": {
              "type": "string",
              "descrption": "prepend an OSC formatted address for every message sent by OSC device"
            }
          }
        }
      }
    }
  }
}



class DPro extends plugin.Plugin {
  constructor() {
    super(schema)
  }

  /**
  * overwrite plugin add function:
  * - add a new Show instance with every added collection
  * - set collection to shows because Show extends from OSCdevice which would otherwise default to device collection for data storage
  * - add show property to cue schema
  *
  * overwrite plugin remove function
  * - remove the show instance
  * - remove its schema properties from the schema
  *
  */
  setup(config) {
    super.setup(config)
      .then(function (result) {
        this.shows.add = function (data) {
          schema.cue[data.name] = {
            "type": "array",
            "items": {
              "type": "object",
              "properties": {}
            },
            "default": [{}]
          }
          data["collection"] = "shows"
          this.shows.items[data.name] = new Show(data, this.db, this.db.shows.document({ "name": data.name }), this.showChanges.bind(this))
        }.bind(this)
        this.shows.remove = function (name) {
          this.shows.items[name].close()
          delete this.shows.items[name]
          delete schema.cue[name]
          this.schemaUpdate(schema)
          log.debug(this.name, "Show removed: " + name)
        }.bind(this)
        this.shows.collectItems()
      }.bind(this))
      .catch(function (error) {
        log.error("D-Pro", error)
      }.bind(this))

    return schema
  }

  cue(data) {
    for (let d in data) {
      if (this.shows.items.hasOwnProperty(d)) {
        this.shows.items[d].send(data[d])
      } else {
        log.error(this.name, "no D-Pro show called " + d)
      }
    }
  }

  command(input) {
    switch (input[0]) {
      case "shows":
        for (let show in this.shows.items) {
          log.info(this.name, show)
        }
        break
      default:
        super.command(input)
        break
    }
  }

  showChanges(changes, show) {
    for (let change in changes) {
      if (change == "schema") {
        schema.cue[show].items.properties = changes[change]
        this.schemaUpdate(schema)
      }
    }
  }
}

/**
* OSC connection to Enttec D-Pro Light Software
*
* registers mapping from d-pro show and converts it to cue shema for level design
* including all cues, snap etc. the d-pro show has to offer
*
* @param {Object} config - device config data. see device.OSCdevice
* @param {Document} device_doc - mongodb document connector
* @param {function} callback - to report schema changes to d-pro plugin
*/
class Show extends device.OSCdevice {
  constructor(config, db, device_doc, callback) {
    super(config, db)
    this.doc = device_doc
    this.mapping = { "btn": {}, "snap": {}, "fade": {} }
    this.callback = callback

    this.doc.get()
      .then(function (data) {
        if (data.hasOwnProperty('mapping')) {
          this.mapping = data.mapping
          this.schemaUpdate()
        }
      }.bind(this))
      .catch(function (err) {
        log.error(this.name, err)
      }.bind(this))

    /** d-pro show properties */
    this.schema = {
      "btn": {
        "title": "cue",
        "type": "object",
        "description": "Run a cue or cuelist.",
        "properties": {}
      },
      "snap": {
        "title": "snapshot",
        "type": "string",
        "description": "Run a snapshot.",
        "enum": []
      },
      "fade": {
        "title": "fade",
        "type": "object",
        "description": "Run the cue or cuelist with the specified level.",
        "properties": {}
      },
      "reset": {
        "type": "boolean",
        "description": "stop all active cues &amp; cuelists",
        "default": true
      },
      "master": {
        "type": "number",
        "format": "range",
        "minimum": 0.0,
        "maximum": 1.0,
        "step": 0.01,
        "descripton": "set the grand master level"
      },
      "speed": {
        "type": "number",
        "minimum": 0.25,
        "maximum": 4.0,
        "format": "range",
        "step": 0.01,
        "descripton": "set the global speed"
      },
      "tempo": {
        "type": "number",
        "minimum": 30.0,
        "maximum": 480.0,
        "format": "range",
        "step": 1,
        "descrption": "set the global speed using a tempo"
      }
    }

    this.schemaUpdate()
  }

  send(msg) {
    let snd = {}
    for (let item in msg) {
      switch (item) {
        case 'btn':
          for (let btn in msg[item]) {
            snd[this.mapping.btn[btn]] = msg[item][btn]
          }
          break

        case 'snap':
          snd[this.mapping.snap[msg[item]]] = 1
          break

        case 'fade':
          for (let fade in msg[item]) {
            snd[this.mapping.fade[fade]] = msg[item][fade]
          }
          break

        case 'reset':
          snd['sc/reset'] = 1
          break

        case 'master':
          snd['sc/gm'] = msg[item]
          break

        case 'speed':
          snd['sc/speed'] = msg[item]
          break

        case 'tempo':
          snd['sc/tempo'] = msg[item]
          break
      }
      super.send(snd)
    }
  }

  /**
  * middle route function to catch and map all label assignments from d-pro
  *
  * remove empty label addresses
  */
  route(osc_msg) {
    if (osc_msg.address.match(/label/g)) {
      let path = osc_msg.address.split('/')
      if (path.length > 2) {
        if (osc_msg.args[0].value == '') {
          if (this.mapping.hasOwnProperty(path[2])) {

            for (let map in this.mapping[path[2]]) {
              if (this.mapping[path[2]][map] == osc_msg.address.replace(/label/g, 'run').substring(1)) {
                delete this.mapping[path[2]][map]
                //log.info(this.name, "remove", osc_msg.address.replace(/label/g, 'run'))
                return null
              }
            }
          }
        } else {
          let addr = osc_msg.address.replace(/label/g, 'run')
          addr = addr.substring(1) // remove leading '/'
          if (this.mapping.hasOwnProperty(path[2])) {

            if (this.mapping[path[2]].hasOwnProperty(osc_msg.args[0].value)) {
              if (this.mapping[path[2]][osc_msg.args[0].value] == addr) {
                return null
              } else {
                log.debug(this.name, "add to mapping:", osc_msg.args[0].value, addr)
                this.mapping[path[2]][osc_msg.args[0].value] = addr
              }
            } else {
              log.debug(this.name, "add to mapping:", osc_msg.args[0].value, addr)
              this.mapping[path[2]][osc_msg.args[0].value] = addr
            }
          }
        }
        this.doc.set({ mapping: this.mapping })
        this.schemaUpdate()
        return null
      }

    } else {
      return super.route(osc_msg)
    }
  }

  schemaUpdate() {
    // BTN
    this.schema.btn.properties = {}
    for (let btn in this.mapping.btn) {
      if (!this.schema.btn.properties.hasOwnProperty(btn)) {
        this.schema.btn.properties[btn] = { "type": "integer", "enum": [0, 1], "default": 1 }
      }
    }
    //SNAP
    this.schema.snap.enum = []
    for (let snap in this.mapping.snap) {
      if (!this.schema.snap.enum.includes(snap)) {
        this.schema.snap.enum.push(snap)
      }
    }
    // FADE
    this.schema.fade.properties = {}
    for (let fade in this.mapping.fade) {
      if (!this.schema.fade.properties.hasOwnProperty(fade)) {
        this.schema.fade.properties[fade] = { "type": "number", "format": "range", "step": 0.01, "minimum": 0.0, "maximum": 1.0, }
      }
    }
    //this.doc.set({"schema":this.schema})
    this.callback({ "schema": this.schema }, this.name)
  }
}

module.exports.Plaitool = DPro
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="module-ableton.html">ableton</a></li><li><a href="module-control.html">control</a></li><li><a href="module-d-pro.html">d-pro</a></li><li><a href="module-device.html">device</a></li><li><a href="module-devices.html">devices</a></li><li><a href="module-errors.html">errors</a></li><li><a href="module-file.html">file</a></li><li><a href="module-game.html">game</a></li><li><a href="module-index.html">index</a></li><li><a href="module-logic.html">logic</a></li><li><a href="module-medley.html">medley</a></li><li><a href="module-mongo.html">mongo</a></li><li><a href="module-ne.html">ne</a></li><li><a href="module-phone.html">phone</a></li><li><a href="module-plugin.html">plugin</a></li><li><a href="module-session.html">session</a></li><li><a href="module-sound.html">sound</a></li><li><a href="module-telegram.html">telegram</a></li><li><a href="module-tradfri.html">tradfri</a></li><li><a href="module-twilio.html">twilio</a></li><li><a href="module-variables.html">variables</a></li></ul><h3>Classes</h3><ul><li><a href="CollectionAPI.html">CollectionAPI</a></li><li><a href="Data.html">Data</a></li><li><a href="module-ableton-Liveset.html">Liveset</a></li><li><a href="module-d-pro-Show.html">Show</a></li><li><a href="module-device-Device.html">Device</a></li><li><a href="module-device-Mididevice.html">Mididevice</a></li><li><a href="module-device-OSCdevice.html">OSCdevice</a></li><li><a href="module-device-Serialdevice.html">Serialdevice</a></li><li><a href="module-device-TCPdevice.html">TCPdevice</a></li><li><a href="module-device-UDPdevice.html">UDPdevice</a></li><li><a href="module-device-Webdevice.html">Webdevice</a></li><li><a href="module-errors-DesignError.html">DesignError</a></li><li><a href="module-game-Game.html">Game</a></li><li><a href="module-logic-Condition.html">Condition</a></li><li><a href="module-logic-Listener.html">Listener</a></li><li><a href="module-medley-Log.html">Log</a></li><li><a href="module-mongo-Collection.html">Collection</a></li><li><a href="module-mongo-Database.html">Database</a></li><li><a href="module-mongo-Document.html">Document</a></li><li><a href="module-ne-Collection.html">Collection</a></li><li><a href="module-ne-Database.html">Database</a></li><li><a href="module-ne-Document.html">Document</a></li><li><a href="module-phone-Phone.html">Phone</a></li><li><a href="module-plugin-Collection.html">Collection</a></li><li><a href="module-plugin-Item.html">Item</a></li><li><a href="module-plugin-Plugin.html">Plugin</a></li><li><a href="module-session-Session.html">Session</a></li><li><a href="module-telegram-Bot.html">Bot</a></li><li><a href="module-twilio-Call.html">Call</a></li><li><a href="module-twilio-CallIn.html">CallIn</a></li><li><a href="module-twilio-SmsIn.html">SmsIn</a></li><li><a href="module-twilio-Switchboard.html">Switchboard</a></li><li><a href="module-variables-Variables.html">Variables</a></li></ul><h3>Global</h3><ul><li><a href="global.html#assignIntro">assignIntro</a></li><li><a href="global.html#assignStory">assignStory</a></li><li><a href="global.html#assignTaskC">assignTaskC</a></li><li><a href="global.html#attendance">attendance</a></li><li><a href="global.html#cancelPlayerSessions">cancelPlayerSessions</a></li><li><a href="global.html#cancelSessions">cancelSessions</a></li><li><a href="global.html#checkQueue">checkQueue</a></li><li><a href="global.html#cooperation">cooperation</a></li><li><a href="global.html#getLocationText">getLocationText</a></li><li><a href="global.html#getLoginLink">getLoginLink</a></li><li><a href="global.html#getPlace">getPlace</a></li><li><a href="global.html#getReader">getReader</a></li><li><a href="global.html#jobData">jobData</a></li><li><a href="global.html#left">left</a></li><li><a href="global.html#nextJob">nextJob</a></li><li><a href="global.html#since">since</a></li><li><a href="global.html#startValues">startValues</a></li><li><a href="global.html#timestamp">timestamp</a></li><li><a href="global.html#updateQueue">updateQueue</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Tue Dec 17 2019 17:26:50 GMT+0100 (CET)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
